diff -urN asterisk-11/channels/chan_sip.c asterisk-11-hangup-replaced/channels/chan_sip.c
--- asterisk-11/channels/chan_sip.c	2014-10-29 10:47:23.000000000 -0700
+++ asterisk-11-hangup-replaced/channels/chan_sip.c	2014-11-03 12:52:40.000000000 -0800
@@ -7046,7 +7046,7 @@
 				}
 
 				/* Send a hangup */
-				if (ast_channel_state(oldowner) == AST_STATE_UP) {
+				if (ast_channel_state(oldowner) == AST_STATE_UP || p->invitereplaces) {
 					transmit_request_with_auth(p, SIP_BYE, 0, XMIT_RELIABLE, 1);
 				}
 
@@ -8593,6 +8593,7 @@
 	make_our_tag(p);
 	p->ocseq = INITIAL_CSEQ;
 	p->allowed_methods = UINT_MAX;
+	p->invitereplaces = 0;
 
 	if (sip_methods[intended_method].need_rtp) {
 		p->maxcallbitrate = default_maxcallbitrate;
@@ -24795,6 +24796,8 @@
 	struct ast_channel *replacecall = p->refer->refer_call->owner;	/* The channel we're about to take over */
 	struct ast_channel *targetcall;		/* The bridge to the take-over target */
 
+	p->refer->refer_call->invitereplaces = 1;
+
 	/* Check if we're in ring state */
 	if (ast_channel_state(replacecall) == AST_STATE_RING)
 		earlyreplace = 1;
@@ -24904,6 +24907,11 @@
 		ast_channel_unlock(c);
 	}
 
+	/* Clear SIP_DEFER_BYE_ON_TRANSFER after the masq to avoid delay hanging up replaced channel */
+	sip_pvt_lock(p);
+	ast_clear_flag(&p->refer->refer_call->flags[0], SIP_DEFER_BYE_ON_TRANSFER);
+	sip_pvt_unlock(p);
+
 	/* c and c's tech pvt must be unlocked at this point for ast_hangup */
 	ast_hangup(c);
 	/* this indicates to handle_request_do that the owner channel has already been unlocked */
diff -urN asterisk-11/channels/sip/include/sip.h asterisk-11-hangup-replaced/channels/sip/include/sip.h
--- asterisk-11/channels/sip/include/sip.h	2014-10-29 10:47:23.000000000 -0700
+++ asterisk-11-hangup-replaced/channels/sip/include/sip.h	2014-11-03 12:47:12.000000000 -0800
@@ -1100,6 +1100,7 @@
 	                                       */
 	unsigned short req_secure_signaling:1;/*!< Whether we are required to have secure signaling or not */
 	unsigned short natdetected:1;         /*!< Whether we detected a NAT when processing the Via */
+	unsigned short invitereplaces:1;      /*!< Whether we are doing an Invite: Replaces */
 	int timer_t1;                     /*!< SIP timer T1, ms rtt */
 	int timer_b;                      /*!< SIP timer B, ms */
 	unsigned int sipoptions;          /*!< Supported SIP options on the other end */
